@interface NSBundle (hys)
/*objectForInfoDictionaryKey:

Returns the value associated with a given key in the receiver's property list.

- (id)objectForInfoDictionaryKey:(NSString *)key
Parameters
key

A key in the receiver's property list.
Return Value

The value associated with key in the receiver's property list (Info.plist). The localized value of a key is returned when one is available.
Discussion

Use of this method is preferred over other access methods because it returns the localized value of a key when one is available. 
Availability
Available in Mac OS X v10.2 and later.*/
- (id)objectForInfoDictionaryKey:(NSString *)key;

/*privateFrameworksPath

Returns the full pathname of the receiver's subdirectory containing private frameworks.

- (NSString *)privateFrameworksPath
Return Value

The full pathname of the receiver's subdirectory containing private frameworks.
Availability
Available in Mac OS X v10.0 and later.*/
- (NSString *)privateFrameworksPath;

@end
