@class NSString, NSArray, NSDictionary;

@interface NSClassDescription  (ADD)
/*attributeKeys

Overridden by subclasses to return the names of attributes of instances of the described class.

- (NSArray *)attributeKeys
Return Value

An array of NSString objects containing the names of attributes of instances of the described class.
Discussion

For example, a class description that describes Movie objects could return the attribute keys title, dateReleased, and rating.

If you have an instance of the class the receiver describes, you can use the NSObject instance method attributeKeys instead.
Availability
Available in Mac OS X v10.0 and later.
See Also
– toManyRelationshipKeys
– toOneRelationshipKeys*/
- (NSArray *)attributeKeys;

@end