#ifndef ABGLOBALSC_H
#define ABGLOBALSC_H

#ifndef __OBJC__

#include <CoreFoundation/CoreFoundation.h>
#endif

/*Person Properties

CFPlugIn defines the following domain qualifier constants.

CFStringRef kABFirstNameProperty;
CFStringRef kABLastNameProperty;
CFStringRef kABFirstNamePhoneticProperty;
CFStringRef kABLastNamePhoneticProperty;
CFStringRef kABBirthdayProperty;
CFStringRef kABOrganizationProperty;
CFStringRef kABJobTitleProperty;
CFStringRef kABHomePageProperty;
CFStringRef kABURLsProperty;
CFStringRef kABEmailProperty;
CFStringRef kABAddressProperty;
CFStringRef kABPhoneProperty;
CFStringRef kABAIMInstantProperty;
CFStringRef kABJabberInstantProperty;
CFStringRef kABMSNInstantProperty;
CFStringRef kABYahooInstantProperty;
CFStringRef kABICQInstantProperty;
CFStringRef kABNoteProperty;
CFStringRef kABMiddleNameProperty;
CFStringRef kABMiddleNamePhoneticProperty;
CFStringRef kABTitleProperty;
CFStringRef kABSuffixProperty;
CFStringRef kABNicknameProperty;
CFStringRef kABMaidenNameProperty;
CFStringRef kABOtherDatesProperty;
CFStringRef kABRelatedNamesProperty;
CFStringRef kABDepartmentProperty;
CFStringRef kABPersonFlags;
Constants
kABFirstNameProperty

First name (string).

Available in Mac OS X v10.2 and later.
kABLastNameProperty

Last name (string).

Available in Mac OS X v10.2 and later.
kABFirstNamePhoneticProperty

First name phonetic (string).

Available in Mac OS X v10.2 and later.
kABLastNamePhoneticProperty

Last name phonetic (string).

Available in Mac OS X v10.2 and later.
kABBirthdayProperty

Birth date (date).

Available in Mac OS X v10.2 and later.
kABOrganizationProperty

Company name (string)

Available in Mac OS X v10.2 and later.
kABJobTitleProperty

Job Title (string).

Available in Mac OS X v10.2 and later.
kABHomePageProperty

Home Web page (string). Deprecated in Mac OS X version 10.4.

Available in Mac OS X v10.2 and later.
kABURLsProperty

Web pages (multi-string). 

Available in Mac OS X v10.4 and later.
kABEmailProperty

email(s) (multi-string).

Available in Mac OS X v10.2 and later.
kABAddressProperty

Street Addresses (multi-dictionary).

Available in Mac OS X v10.2 and later.
kABPhoneProperty

Generic phone number (multi-string).

Available in Mac OS X v10.2 and later.
kABAIMInstantProperty

AIM Instant Messaging (multi-string).

Available in Mac OS X v10.2 and later.
kABJabberInstantProperty

Jabber Instant Messaging (multi-string).

Available in Mac OS X v10.2 and later.
kABMSNInstantProperty

MSN Instant Messaging (multi-string).

Available in Mac OS X v10.2 and later.
kABYahooInstantProperty

Yahoo Instant Messaging (multi-string).

Available in Mac OS X v10.2 and later.
kABICQInstantProperty

ICQ Instant Messaging (multi-string).

Available in Mac OS X v10.2 and later.
kABNoteProperty

Note (string).

Available in Mac OS X v10.2 and later.
kABMiddleNameProperty

Middle name (string). Not supported in the AddressBook UI.

Available in Mac OS X v10.2 and later.
kABMiddleNamePhoneticProperty

Middle name phonetic (string). Not supported in the AddressBook UI.

Available in Mac OS X v10.2 and later.
kABTitleProperty

Title as in “Sir”, “Duke”, “General”, “Cardinal”, or “Lord” (string). Not supported in the AddressBook UI.

Available in Mac OS X v10.2 and later.
kABSuffixProperty

Suffix as in “Sr.”, “Jr.”, “III”, or “Esq.” (string). Not supported in the AddressBook UI.

Available in Mac OS X v10.2 and later.
kABNicknameProperty

Nickname (string). Not supported in the AddressBook UI.

Available in Mac OS X v10.2 and later.
kABMaidenNameProperty

Maiden name (string). Not supported in the AddressBook UI.

Available in Mac OS X v10.2 and later.
kABOtherDatesProperty

Dates associated with a person (ABMultiDateProperty containing dates).

Available in Mac OS X v10.3 and later.
kABRelatedNamesProperty

Names of people related to a person (ABMultiStringProperty containing names).

Available in Mac OS X v10.3 and later.
kABDepartmentProperty

Department name (string).

Available in Mac OS X v10.3 and later.
kABPersonFlags

Property that specifies the name ordering and user configuration of a record in the Address Book application.

Available in Mac OS X v10.3 and later.*/

CFStringRef kABFirstNameProperty;
CFStringRef kABLastNameProperty;
CFStringRef kABFirstNamePhoneticProperty;
CFStringRef kABLastNamePhoneticProperty;
CFStringRef kABBirthdayProperty;
CFStringRef kABOrganizationProperty;
CFStringRef kABJobTitleProperty;
CFStringRef kABHomePageProperty;
CFStringRef kABURLsProperty;
CFStringRef kABEmailProperty;
CFStringRef kABAddressProperty;
CFStringRef kABPhoneProperty;
CFStringRef kABAIMInstantProperty;
CFStringRef kABJabberInstantProperty;
CFStringRef kABMSNInstantProperty;
CFStringRef kABYahooInstantProperty;
CFStringRef kABICQInstantProperty;
CFStringRef kABNoteProperty;
CFStringRef kABMiddleNameProperty;
CFStringRef kABMiddleNamePhoneticProperty;
CFStringRef kABTitleProperty;
CFStringRef kABSuffixProperty;
CFStringRef kABNicknameProperty;
CFStringRef kABMaidenNameProperty;
CFStringRef kABOtherDatesProperty;
CFStringRef kABRelatedNamesProperty;
CFStringRef kABDepartmentProperty;
CFStringRef kABPersonFlags;


#endif
