#import <Cocoa/Cocoa.h>


@class ABRecord, ABPerson, ABGroup;

@interface ABPeoplePickerView : NSView

/*selectedGroups

- (NSArray *)selectedGroups
Discussion

Returns the groups selected in the group list as an array of ABGroup objects.
Availability
Available in Mac OS X v10.3 and later.*/
- (NSArray *)selectedGroups;

/*selectedRecords

- (NSArray *)selectedRecords
Discussion

Returns the selection in the record list as an array of ABGroup or ABPerson objects.
Availability
Available in Mac OS X v10.3 and later.
See Also
– selectRecord:byExtendingSelection:
– deselectRecord:*/
- (NSArray *)selectedRecords;

/*addProperty:

- (void)addProperty:(NSString *)property
Discussion

Adds a property to the group of properties whose values are shown in the record list.

For additional information about properties see “Person Properties”
Availability
Available in Mac OS X v10.3 and later.
See Also
– removeProperty:
– properties*/
- (void)addProperty:(NSString *)property;

/*removeProperty:

- (void)removeProperty:(NSString *)property
Discussion

Removes a property from the group of properties whose values are shown in the record list.

For additional information about properties see “Person Properties”
Availability
Available in Mac OS X v10.3 and later.
See Also
– addProperty:
– properties*/
- (void)removeProperty:(NSString *)property;

/*editInAddressBook:

- (void)editInAddressBook:(id)sender
Discussion

Launches Address Book to edit the item selected in the people picker.
Availability
Available in Mac OS X v10.3 and later.
See Also
– selectInAddressBook:*/
- (void)editInAddressBook:(id)sender;

/*selectInAddressBook:

- (void)selectInAddressBook:(id)sender
Discussion

Launches Address Book and selects the item selected in the people picker.
Availability
Available in Mac OS X v10.3 and later.
See Also
– editInAddressBook:*/
- (void)selectInAddressBook:(id)sender;

@end

//@interface ABPeoplePickerView (ABPeoplePickerConvenience)

//@end


