#import <AppKit/NSControl.h>
@class NSImage;

@interface NSSegmentedControl : NSControl 

/*selectedSegment

Returns the index of the selected segment of the receiver.

- (int)selectedSegment
Return Value

The index of the currently selected segment or -1 if no segment is selected. If the receiver allows multiple selections, this method returns the most recently selected segment.
Availability
Available in Mac OS X v10.3 and later.
See Also
– setSelectedSegment:*/
- (int)selectedSegment;

/*setImage:forSegment:

Sets the image for the specified segment.

- (void)setImage:(NSImage *)image forSegment:(int)segment
Parameters
image

The image to apply to the segment or nil if you want to clear the existing image. Images are not scaled to fit inside a segment. If the image is larger than the available space, it is clipped. 
segment

The index of the segment whose image you want to set. This method raises an NSRangeException if the index is out of bounds.
Availability
Available in Mac OS X v10.3 and later.
See Also
– imageForSegment:*/
- (void)setImage:(NSImage *)image forSegment:(int)segment;

@end

