#import <Foundation/NSObject.h>
#import <CoreData/CoreDataDefines.h>

/*Error User Info Keys

Core Data uses these string constants as keys in the user info dictionary in errors it creates.

const NSString *NSDetailedErrorsKey;
const NSString *NSValidationObjectErrorKey;
const NSString *NSValidationKeyErrorKey;
const NSString *NSValidationPredicateErrorKey;
const NSString *NSValidationValueErrorKey;
const NSString *NSAffectedStoresErrorKey;
const NSString *NSAffectedObjectsErrorKey;
Constants
NSDetailedErrorsKey

If multiple validation errors occur in one operation, they are collected in an array and added with this key to the “top-level error” of the operation.

Available in Mac OS X v10.4 and later.
NSValidationObjectErrorKey

Key for the object that failed to validate for a validation error.

Available in Mac OS X v10.4 and later.
NSValidationKeyErrorKey

Key for the key that failed to validate for a validation error.

Available in Mac OS X v10.4 and later.
NSValidationPredicateErrorKey

For predicate-based validation, key for the predicate for the condition that failed to validate.

Available in Mac OS X v10.4 and later.
NSValidationValueErrorKey

If non-nil, the key for the value for the key that failed to validate for a validation error.

Available in Mac OS X v10.4 and later.
NSAffectedStoresErrorKey

The key for stores prompting an error.

Available in Mac OS X v10.4 and later.
NSAffectedObjectsErrorKey

The key for objects prompting an error.

Available in Mac OS X v10.4 and later.
Availability
Available in Mac OS X v10.4 and later. 
Declared In
CoreData/CoreDataErrors.h*/

const NSString *NSDetailedErrorsKey;
const NSString *NSValidationObjectErrorKey;
const NSString *NSValidationKeyErrorKey;
const NSString *NSValidationPredicateErrorKey;
const NSString *NSValidationValueErrorKey;
const NSString *NSAffectedStoresErrorKey;
const NSString *NSAffectedObjectsErrorKey;

