
#ifndef DRCONTENTFOLDER_H
#define DRCONTENTFOLDER_H

#if PRAGMA_ONCE
#pragma once
#endif

#ifndef DRCONTENTOBJECT_H
#include <DiscRecordingContent/DRContentObject.h>
#endif

#ifndef   CFURL_H
#include <CoreFoundation/CFURL.h>
#endif

#ifndef  AVAILABILITYMACROS_H
#include <AvailabilityMacros.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

/*DRFolderCreateReal


Creates a new real folder object corresponding to a given FSRef object. 
extern DRFolderRef DRFolderCreateReal( 
    const FSRef *fsRef) ;  
Parameters
fsRef
A file-system reference to an on-disk folder.
Return Value

Returns a reference to the newly-created folder object, or NULL. 
Discussion 

A real folder object is a folder object corresponding to a real folder on disk. The content of the folder object corresponds to the actual on-disk content of the folder. Items cannot be programatically added to or removed from a real folder object without making it virtual first -- see DRFolderConvertRealToVirtual . 
Availability
Introduced in Mac OS X v10.2*/
extern DRFolderRef DRFolderCreateReal( 
    const FSRef *fsRef) ;  



#ifdef __cplusplus
}
#endif

#endif 

