#import <Cocoa/Cocoa.h>
#import <DiscRecording/DiscRecording.h>
#import <AvailabilityMacros.h>
@class DREraseSetupPanel;


@interface DREraseProgressPanel : NSPanel


/*progressPanel


Creates and returns an instance of the erase progress panel. 
+ (DREraseProgressPanel*) progressPanel; 
Return Value

A pointer to the newly created DREraseProgressPanel.*/
+ (DREraseProgressPanel*) progressPanel; 

/*beginProgressPanelForErase:


Presents the progress panel on screen and begins the erase process. 
- (void) beginProgressPanelForErase:(DRErase*)erase; 
Parameters
erase
The object performing the erase.
Discussion 

This method returns control to the caller after it has displayed the progress sheet and begun the erase. Once the method has returned the caller can perform other operations while the erase continues.*/
- (void) beginProgressPanelForErase:(DRErase*)erase; 


@end
//@interface NSObject (DREraseProgressPanelDelegateMethods)

//@end

/*DREraseProgressPanelDidFinishNotification


Posted when the DREraseProgressPanel has finished and is about to go away. 
extern NSString* const DREraseProgressPanelDidFinishNotification ;  
Discussion 

This notification contains a notification object but no userInfo dictionary. The notification object is the DREraseProgressPanel that will be closed. 
Availability
Introduced in Mac OS X v10.2*/
extern NSString* const DREraseProgressPanelDidFinishNotification ;  