
#import <DiscRecording/DiscRecording.h>
#import <DiscRecordingUI/DRSetupPanel.h>

@interface DREraseSetupPanel : DRSetupPanel
/*setupPanel


Returns an instance of a erase setup panel. 
+ (DREraseSetupPanel*) setupPanel; 
Return Value

An erase setup panel.*/
+ (DREraseSetupPanel*) setupPanel; 


/*eraseObject


Creates and returns a new DRErase object that's configured to erase the disc in the currently selected device. 
- (DRErase*) eraseObject; 
Return Value

A new DRErase object. 
Discussion 

The new DRErase object is configured based on the settings in the setup panel when the user clicks the OK button.
Do not invoke this method within a modal session (runSetupPanel or beginSetupSheetForWindow:modalDelegate:didEndSelector:contextInfo: ) because the erase object information is only updated just before the modal session ends.*/
- (DRErase*) eraseObject; 


@end
