

#import <Cocoa/Cocoa.h>
#import <DiscRecording/DiscRecording.h>
#import <AvailabilityMacros.h>

@interface DRSetupPanel : NSPanel
/*runSetupPanel


Displays the receiver and begins its event loop. 
- (int) runSetupPanel; 
Return Value

Returns NSOKButton (if the user clicks the default button) or NSCancelButton (if the user clicks the Cancel button). 
Discussion 

Invokes NSApplication's runModalForWindow: method with self as the argument.*/
- (int) runSetupPanel; 

/*beginSetupSheetForWindow:modalDelegate:didEndSelector:contextInfo:


Presents a setup panel as a sheet. 
- (void) beginSetupSheetForWindow:(NSWindow*)owner 
        modalDelegate:(id)modalDelegate didEndSelector:(SEL)didEndSelector 
        contextInfo:(void*)contextInfo; 
Parameters
owner
The window the sheet will be attached to. If owner is not nil, the setup panel slides down as a sheet running as a document modal window. If owner is nil, this is an error.
modalDelegate
The modal delegate. The object that implements the didEndSelector.
didEndSelector
Selector to invoke when the sheet ends. This selector is optional. If implemented by the modal delegate, this method is invoked after the modal session has ended, but before dismissing the same panel. didEndSelector may dismiss the save panel itself otherwise it will be dismissed on return from the method. didEndSelector should have the following signature: 

- (void)setupPanelDidEnd:(DRSetupPanel*)panel returnCode:(int)returnCode contextInfo:(void*)contextInfo

contextInfo
Context information to be passed when the selector named by didEndSelector is invoked.*/
- (void) beginSetupSheetForWindow:(NSWindow*)owner 
        modalDelegate:(id)modalDelegate didEndSelector:(SEL)didEndSelector 
        contextInfo:(void*)contextInfo; 

@end

//@interface NSObject(DRSetupPanelDelegate)

//@end
