
#ifndef FILETYPESANDCREATORS_H
#define FILETYPESANDCREATORS_H

#ifndef  CONDITIONALMACROS_H
#include <CarbonCore/ConditionalMacros.h>
#endif




#if PRAGMA_ONCE
#pragma once
#endif

#ifdef __cplusplus
extern "C" {
#endif

/*File Types and Creators

Identify the formats of graphics files and the applications that create them.

// File types
ftAdobePremiereMovie      ='MooV'
ftAfterDarkModule         ='ADgm'
ftClip3Dgraphic           ='EZ3D'
ftCricketChart            ='CGPC'
ftCricketDrawing          ='CKDT'
ftDesignCADDrawing        ='DCAD'
ftImageStudioGraphic      ='RIFF'
ftKaleidaGraphGraphic     ='QPCT'
ftMacFlowChart            ='FLCH'
ftMacSpinDataSet          ='D2BN'
ftMoviePlayerMovie        ='MooV'
ftPixelPaint              ='PX01'
ftSuper3DDrawing          ='3DBX'
ftSwivel3DDrawing         ='SMDL'
ftVersaCADDrawing         ='2D  '
// Creator codes
sigAdobePremiere          ='PrMr'
sigAfterDark              ='ADrk'
sigAldusSuper3D           ='SP3D'
sigAutoCAD                ='ACAD'
sigClip3D                 ='EZ3E'
sigCricketDraw            ='CRDW'
sigCricketGraph           ='CGRF'
sigDeltagraphPro          ='DGRH'
sigDesign2                ='DESG'
sigDesignCAD              ='ASBC'
sigDesignStudio           ='MRJN'
sigDigDarkroom            ='DIDR'
sigDreams                 ='PHNX'
sigDynaperspective        ='PERS'
sigGenericCADD            ='CAD3'
sigGraphMaster            ='GRAM'
sigImageStudio            ='FSPE'
sigInfiniD                ='SI∞D'
sigKaleidaGraph           ='QKPT'
sigKidPix                 ='Kid2'
sigLabVIEW                ='LBVW'
sigMacDraft               ='MD20'
sigMacDraw                ='MDRW'
sigMacFlow                ='MCFL'
sigMacSpin                ='D2SP'
sigMiniCad                ='CDP3'
sigModelShop              ='MDSP'
sigMoviePlayer            ='TVOD'
sigMovieRecorder          ='mrcr'
sigOasis                  ='TAOA'
sigOBJECTMASTER           ='BROW'
sigOfoto                  ='APLS'
sigOmnis5                 ='Q2$$'
sigOptix                  ='PIXL'
sigPhotoMac               ='PMAC'
sigPictureCompressor      ='ppxi'
sigPICTViewer             ='MDTS'
sigPixelPaint             ='PIXR'
sigScreenPlay             ='SPLY'
sigSmoothie               ='Smoo'
sigStudio1                ='ST/1'
sigStudio32               ='ST32'
sigStudio8                ='ST/8'
sigSwivel3D               ='SWVL'
sigVersaCad               ='VCAD'
Discussion

Constant names for creator codes are written as sig followed by the application name. Constant names for file types are written as ft followed by the document type.*/
// File types
enum {
ftAdobePremiereMovie      ='MooV',
ftAfterDarkModule         ='ADgm',
ftClip3Dgraphic           ='EZ3D',
ftCricketChart            ='CGPC',
ftCricketDrawing          ='CKDT',
ftDesignCADDrawing        ='DCAD',
ftImageStudioGraphic      ='RIFF',
ftKaleidaGraphGraphic     ='QPCT',
ftMacFlowChart            ='FLCH',
ftMacSpinDataSet          ='D2BN',
ftMoviePlayerMovie        ='MooV',
ftPixelPaint              ='PX01',
ftSuper3DDrawing          ='3DBX',
ftSwivel3DDrawing         ='SMDL',
ftVersaCADDrawing         ='2D  ',
// Creator codes
sigAdobePremiere          ='PrMr',
sigAfterDark              ='ADrk',
sigAldusSuper3D           ='SP3D',
sigAutoCAD                ='ACAD',
sigClip3D                 ='EZ3E',
sigCricketDraw            ='CRDW',
sigCricketGraph           ='CGRF',
sigDeltagraphPro          ='DGRH',
sigDesign2                ='DESG',
sigDesignCAD              ='ASBC',
sigDesignStudio           ='MRJN',
sigDigDarkroom            ='DIDR',
sigDreams                 ='PHNX',
sigDynaperspective        ='PERS',
sigGenericCADD            ='CAD3',
sigGraphMaster            ='GRAM',
sigImageStudio            ='FSPE',
sigInfiniD                ='SI∞D',
sigKaleidaGraph           ='QKPT',
sigKidPix                 ='Kid2',
sigLabVIEW                ='LBVW',
sigMacDraft               ='MD20',
sigMacDraw                ='MDRW',
sigMacFlow                ='MCFL',
sigMacSpin                ='D2SP',
sigMiniCad                ='CDP3',
sigModelShop              ='MDSP',
sigMoviePlayer            ='TVOD',
sigMovieRecorder          ='mrcr',
sigOasis                  ='TAOA',
sigOBJECTMASTER           ='BROW',
sigOfoto                  ='APLS',
sigOmnis5                 ='Q2$$',
sigOptix                  ='PIXL',
sigPhotoMac               ='PMAC',
sigPictureCompressor      ='ppxi',
sigPICTViewer             ='MDTS',
sigPixelPaint             ='PIXR',
sigScreenPlay             ='SPLY',
sigSmoothie               ='Smoo',
sigStudio1                ='ST/1',
sigStudio32               ='ST32',
sigStudio8                ='ST/8',
sigSwivel3D               ='SWVL',
sigVersaCad               ='VCAD'
};


#ifdef __cplusplus
}
#endif

#endif
