
#import <Foundation/NSObject.h>

@class NSArray, NSAppleEventDescriptor, NSScriptClassDescription, NSScriptWhoseTest, NSString;



@interface NSScriptObjectSpecifier : NSObject <NSCoding> 
@end


@interface NSObject (NSScriptObjectSpecifiers)


@end



@interface NSIndexSpecifier : NSScriptObjectSpecifier {}

@end


@interface NSMiddleSpecifier : NSScriptObjectSpecifier {}

@end


@interface NSNameSpecifier : NSScriptObjectSpecifier 

@end

@interface NSPositionalSpecifier : NSObject 
@end


@interface NSPropertySpecifier : NSScriptObjectSpecifier {}

@end




@interface NSRandomSpecifier : NSScriptObjectSpecifier {}

@end




@interface NSRangeSpecifier : NSScriptObjectSpecifier

@end


@interface NSRelativeSpecifier : NSScriptObjectSpecifier
@end



@interface NSUniqueIDSpecifier : NSScriptObjectSpecifier {

}
/*initWithContainerClassDescription:containerSpecifier:key:uniqueID:

Returns an NSUniqueIDSpecifier object, initialized with the given arguments.

- (id)initWithContainerClassDescription:(NSScriptClassDescription *)classDesc containerSpecifier:(NSScriptObjectSpecifier *)container key:(NSString *)property uniqueID:(id)uniqueID
Parameters
classDesc

The class description for the new object.
container

The container for the new object.
property

The property for the new object.
uniqueID

The unique ID for the new object.

uniqueID must be an instance of NSNumber or NSString. The type should match the declared type of the attribute of the specified scriptable class whose four-character code is 'ID '.
Return Value

An NSUniqueIDSpecifier object, initialized with the given arguments. 
Discussion

Invokes the super class’s initWithContainerClassDescription:containerSpecifier:key: method and sets the ID to uniqueID.
Availability
Available in Mac OS X v10.2 and later.*/
- (id)initWithContainerClassDescription:(NSScriptClassDescription *)classDesc containerSpecifier:(NSScriptObjectSpecifier *)container key:(NSString *)property uniqueID:(id)uniqueID;


@end

@interface NSWhoseSpecifier : NSScriptObjectSpecifier {
}

@end
