
#import <Foundation/NSObject.h>

@class NSArray, NSBundle, NSData, NSDictionary, NSMutableArray, NSMutableDictionary, NSMutableSet, NSScriptClassDescription, NSScriptCommandDescription;

@interface NSScriptSuiteRegistry : NSObject
/*sharedScriptSuiteRegistry

Returns the single, shared instance of NSScriptSuiteRegistry, creating it first if it doesn’t exist.

+ (NSScriptSuiteRegistry *)sharedScriptSuiteRegistry
Discussion

If it creates an instance, and if the application provides scriptability information in the script suite format, the method loads suite definitions in all frameworks and other bundles that the application currently imports or includes; if information is provided in the sdef format, the method loads information only from the specified sdef file. If in reading scriptability information an exception is raised because of parsing errors, it handles the exception by printing a line of information to the console.
Availability
Available in Mac OS X v10.0 and later.
See Also
– loadSuiteWithDictionary:fromBundle:*/
+ (NSScriptSuiteRegistry *)sharedScriptSuiteRegistry;

@end
