#ifndef TRANSLATION_H
#define TRANSLATION_H


#ifndef CORESERVICES_H
#include <CoreServices/CoreServices.h>
#endif

#ifndef TRANSLATIONEXTENSIONS_H
#include <HIToolbox/TranslationExtensions.h>
#endif



#include <AvailabilityMacros.h>

#if PRAGMA_ONCE
#pragma once
#endif

#ifdef __cplusplus
extern "C" {
#endif

/*FileTranslationSpec

Defines a file translation method supported by the Translation Manager.

struct FileTranslationSpec {
   OSType          componentSignature;
   const void *    translationSystemInfo;
   FileTypeSpec    src;
   FileTypeSpec    dst;
};
typedef struct FileTranslationSpec      FileTranslationSpec;
typedef FileTranslationSpec *           FileTranslationSpecArrayPtr;
typedef FileTranslationSpecArrayPtr *   FileTranslationSpecArrayHandle;
Availability
Available in Mac OS X v10.0 and later.*/
struct FileTranslationSpec {
   OSType          componentSignature;
   const void *    translationSystemInfo;
   FileTypeSpec    src;
   FileTypeSpec    dst;
};
typedef struct FileTranslationSpec      FileTranslationSpec;
typedef FileTranslationSpec *           FileTranslationSpecArrayPtr;
typedef FileTranslationSpecArrayPtr *   FileTranslationSpecArrayHandle;

#ifdef __cplusplus
}
#endif

#endif