#ifndef IOMEDIA_H
#define IOMEDIA_H

#include <IOKit/IOTypes.h>
/*kIOMediaEjectableKey


A property of IOMedia objects.
#define kIOMediaEjectableKey "Ejectable" 
Discussion 

The kIOMediaEjectableKey property has an OSBoolean value and describes whether the media is ejectable from the drive mechanism under software control. Implies IOMediaRemovable is also true.*/
#define kIOMediaEjectableKey "Ejectable" 

/*kIOMediaClass


The name of the IOMedia class. 
#define kIOMediaClass "IOMedia" */
#define kIOMediaClass "IOMedia"

/*kIOMediaWholeKey


A property of IOMedia objects.
#define kIOMediaWholeKey "Whole" 
Discussion 

The kIOMediaWholeKey property has an OSBoolean value and describes whether the media is whole, that is, it represents the whole disk (the physical disk, or a virtual replica thereof).*/
#define kIOMediaWholeKey "Whole" 

#endif