#ifndef MDIMPORTER_H
#define MDIMPORTER_H


#include <CoreFoundation/CoreFoundation.h>
#include <Metadata/MDItem.h>
#include <HYS/Metadata/MDImporter.h>


#if defined(__cplusplus)
extern "C" {
#endif

/*kMDImporterTypeID

Type ID of an importer plug-in.

#define kMDImporterTypeID  CFUUIDGetConstantUUIDWithBytes(kCFAllocatorDefault,
0x8B,
0x08,
0xC4,
0xBF,
0x41,
0x5 B,
0x11,
0xD8,
0xB3,
0xF9,
0x00,
0x03,
0x93,
0x67,
0x26,
0xFC);
Constants
kMDImporterTypeID

Only importers with this type ID are loaded.

Available in Mac OS X v10.4 and later.
Discussion

The string representation of this UUID is 8B08C4BF-415B-11D8-B3F9-00039*/
#define kMDImporterTypeID  \
CFUUIDGetConstantUUIDWithBytes(\
kCFAllocatorDefault,\
 0x8B, \
0x08,\
0xC4,\
0xBF,\
0x41,\
0x5B,\
0x11,\
0xD8,\
0xB3,\
0xF9,\
0x00,\
0x03,\
0x93,\
0x67,\
0x26,\
0xFC)


/*kMDImporterInterfaceID

Interface required by a importer plug-in.

#define kMDImporterInterfaceID  CFUUIDGetConstantUUIDWithBytes(kCFAllocatorDefault,
0x6E,
0xBC,
0x27,
0xC4,
0x89,
0x9 C,
0x11,
0xD8,
0x84,
0xAE,
0x00,
0x03,
0x93,
0x67,
0x26,
0xFC);
Constants
kMDImporterInterfaceID

Importers must implement an interface corresponding to this UUID.

Available in Mac OS X v10.4 and later.
Discussion

The string representation of this UUID is 6EBC27C4-899C-11D8-84A3-0003936726FC.*/
#define kMDImporterInterfaceID  CFUUIDGetConstantUUIDWithBytes(kCFAllocatorDefault,\
0x6E, 0xBC,0x27,0xC4,0x89,0x9C,0x11,0xD8,0x84,0xAE,0x00,0x03,0x93,0x67,0x26,0xFC)






#if defined(__cplusplus)
}
#endif


#endif
