#ifndef SCSI_H
#define SCSI_H

#ifndef MACTYPES_H
#include <CarbonCore/MacTypes.h>
#endif

#ifndef MIXEDMODE_H
#include <CarbonCore/MixedMode.h>
#endif



#include <AvailabilityMacros.h>

#if PRAGMA_ONCE
#pragma once
#endif

#ifdef __cplusplus
extern "C" {
#endif

/*DeviceIdent

You use the device identification record to specify a target device by its bus, SCSI ID, and logical unit number (LUN). 

struct DeviceIdent {
   UInt8 diReserved;
   UInt8 bus;
   UInt8 targetID;
   UInt8 LUN;
};
typedef struct DeviceIdent DeviceIdent;
Fields
diReserved

Reserved.
bus

The bus number of the SIM/HBA for the target device. 
targetID

The SCSI ID number of the target device. 
LUN

The target LUN, or 0 if the device does not support logical units. 
Availability
Available in Mac OS X v10.0 and later.*/
struct DeviceIdent {
   UInt8 diReserved;
   UInt8 bus;
   UInt8 targetID;
   UInt8 LUN;
};
typedef struct DeviceIdent DeviceIdent;


#ifdef __cplusplus
}
#endif

#endif