
#ifndef CGLRENDERERS_H
#define CGLRENDERERS_H

/*Renderer IDs

Define constants that specify hardware and software renderers.

kCGLRendererGenericID         0x00020200
kCGLRendererGenericFloatID    0x00020400
kCGLRendererAppleSWID         0x00020600
kCGLRendererATIRage128ID      0x00021000
kCGLRendererATIRadeonID       0x00021200
kCGLRendererATIRageProID      0x00021400
kCGLRendererATIRadeon8500ID   0x00021600
kCGLRendererATIRadeon9700ID   0x00021800
kCGLRendererGeForce2MXID      0x00022000
kCGLRendererGeForce3ID        0x00022200
kCGLRendererGeForceFXID       0x00022400
kCGLRendererVTBladeXP2ID      0x00023000
kCGLRendererMesa3DFXID        0x00040000
Constants
kCGLRendererGenericID

Specifies the software renderer. Deprecated on Intel-based Macintosh computers.

Available in Mac OS X v10.4 and later.
kCGLRendererGenericFloatID

Specifies the floating-point software renderer. 

Available in Mac OS X v10.4 and later.
kCGLRendererAppleSWID

Specifies the Apple software renderer ID. 

Available in Mac OS X v10.4 and later.
kCGLRendererATIRage128ID

Specifies the ATI Rage128 renderer.

Available in Mac OS X v10.4 and later.
kCGLRendererATIRadeonID

Specifies the ATI Radeon renderer.

Available in Mac OS X v10.4 and later.
kCGLRendererATIRageProID

Specifies the ATI RagePro renderer.

Available in Mac OS X v10.4 and later.
kCGLRendererATIRadeon8500ID

Specifies the ATI Radeon 8500 renderer.

Available in Mac OS X v10.4 and later.
kCGLRendererATIRadeon9700ID

Specifies the ATI Radeon 9700 renderer.

Available in Mac OS X v10.4 and later.
kCGLRendererGeForce2MXID

Specifies the NVIDIA GeForce2MX renderer.

Available in Mac OS X v10.4 and later.
kCGLRendererGeForce3ID

Specifies the NVIDIA GeForce3 renderer.

Available in Mac OS X v10.4 and later.
kCGLRendererGeForceFXID

Specifies the NVIDIA GeForceFX renderer.

Available in Mac OS X v10.4 and later.
kCGLRendererVTBladeXP2ID

Specifies the VTBook renderer.

Available in Mac OS X v10.4 and later.
kCGLRendererMesa3DFXID

Specifies the Mesa 3DFX renderer.

Available in Mac OS X v10.4 and later.
Availability
Available in Mac OS X v10.0 and later.
Declared In
CGLRenderers.h*/
#define kCGLRendererGenericID         0x00020200
#define kCGLRendererGenericFloatID    0x00020400
#define kCGLRendererAppleSWID         0x00020600
#define kCGLRendererATIRage128ID      0x00021000
#define kCGLRendererATIRadeonID       0x00021200
#define kCGLRendererATIRageProID      0x00021400
#define kCGLRendererATIRadeon8500ID   0x00021600
#define kCGLRendererATIRadeon9700ID   0x00021800
#define kCGLRendererGeForce2MXID      0x00022000
#define kCGLRendererGeForce3ID        0x00022200
#define kCGLRendererGeForceFXID       0x00022400
#define kCGLRendererVTBladeXP2ID      0x00023000
#define kCGLRendererMesa3DFXID        0x00040000

#endif 
