

@class PDFPage, PDFDestinationPrivateVars;


@interface PDFDestination : NSObject

/*initWithPage:atPoint:

Initializes the destination.

- (id)initWithPage:(PDFPage *)page atPoint:(NSPoint)point
Discussion

Specify point in page space. Typically, there’s no need to initialize destinations. Instead, you get them from PDFAnnotationLink, PDFOutline, or PDFView objects.

Page space is a 72 dpi coordinate system with the origin at the lower-left corner of the current page.
Availability
Available in Mac OS X v10.4 and later.*/
- (id)initWithPage:(PDFPage *)page atPoint:(NSPoint)point;

/*page

Gets the page that the destination refers to.

- (PDFPage *)page
Availability
Available in Mac OS X v10.4 and later.
See Also
– point*/
- (PDFPage *)page;

@end
