#ifndef  SCDYNAMICSTORECOPYSPECIFIC_H
#define SCDYNAMICSTORECOPYSPECIFIC_H

#include <sys/cdefs.h>
#include <sys/types.h>
#include <CoreFoundation/CoreFoundation.h>
#include <SystemConfiguration/SCDynamicStore.h>

/*SCDynamicStoreCopyProxies

CFDictionaryRef SCDynamicStoreCopyProxies ( 
    SCDynamicStoreRef store );  
Parameters
store
An SCDynamicStoreRef representing the dynamic store session that should be used for communication with the server. If NULL, a temporary session will be used.
Return Value

Returns a dictionary containing key-value pairs that represent the current internet proxy settings; NULL if no proxy settings have been defined or if an error was encountered. You must release the returned value. 
Discussion 

Gets the current internet proxy settings. The returned proxy settings dictionary includes: 
key 	type 	description 
kSCPropNetProxiesExceptionsList	CFArray[CFString]	Host name patterns which should bypass the proxy
kSCPropNetProxiesHTTPEnable	CFNumber (0 or 1)	Enables/disables the use of an HTTP proxy
kSCPropNetProxiesHTTPProxy	CFString	The proxy host
kSCPropNetProxiesHTTPPort	CFNumber	The proxy port number
kSCPropNetProxiesHTTPSEnable	CFNumber (0 or 1)	Enables/disables the use of an HTTPS proxy
kSCPropNetProxiesHTTPSProxy	CFString	The proxy host
kSCPropNetProxiesHTTPSPort	CFNumber	The proxy port number
kSCPropNetProxiesFTPEnable	CFNumber (0 or 1)	Enables/disables the use of an FTP proxy
kSCPropNetProxiesFTPProxy	CFString	The proxy host
kSCPropNetProxiesFTPPort	CFNumber	The proxy port number
kSCPropNetProxiesFTPPassive	CFNumber (0 or 1)	Enable passive mode operation for use behind connection filter-ing firewalls.



Other key-value pairs are defined in the SCSchemaDefinitions.h header file.*/
CFDictionaryRef SCDynamicStoreCopyProxies (
    SCDynamicStoreRef store );

#endif
