#import <AppKit/NSDatePicker.h>

@implementation NSDatePicker
/*setDatePickerElements:

Sets the date picker elements displayed by the receiver to those specified by elementFlags.

- (void)setDatePickerElements:(unsigned)elementFlags
Discussion

See “Constants” for a description of the possible values.
Availability
Available in Mac OS X v10.4 and later.
See Also
– datePickerElements*/
- (void)setDatePickerElements:(unsigned)elementFlags{}


/*setDateValue:

Sets the date of the receiver to newStartDate.

- (void)setDateValue:(NSDate *)newStartDate
Availability
Available in Mac OS X v10.4 and later.
See Also
– dateValue*/
- (void)setDateValue:(NSDate *)newStartDate{}


/*setDatePickerStyle:

Sets the receiver’s date picker style to newStyle.

- (void)setDatePickerStyle:(NSDatePickerStyle)newStyle
Discussion

See “Constants” for a description of the possible values.
Availability
Available in Mac OS X v10.4 and later.
See Also
– datePickerStyle*/
- (void)setDatePickerStyle:(NSDatePickerStyle)newStyle{}

/*setDrawsBackground:

- (void)setDrawsBackground:(BOOL)flag
Discussion

Sets whether the receiver draws the background.
Availability
Available in Mac OS X v10.4 and later.
See Also
– drawsBackground*/
- (void)setDrawsBackground:(BOOL)flag{}


/*dateValue

Returns the receiver’s date.

- (NSDate *)dateValue
Availability
Available in Mac OS X v10.4 and later.
See Also
– setDateValue:*/
- (NSDate *)dateValue{}


/*setTextColor:

Sets the text color of the receiver to color.

- (void)setTextColor:(NSColor *)color
Availability
Available in Mac OS X v10.4 and later.
See Also
– textColor*/
- (void)setTextColor:(NSColor *)color{}

/*setMinDate:

Sets the minimum date allowed as input by the receiver to date.

- (void)setMinDate:(NSDate *)date
Discussion

Passing nil for date allows any date as the minimum value.
Availability
Available in Mac OS X v10.4 and later.
See Also
– minDate*/
- (void)setMinDate:(NSDate *)date{}


/*setTimeInterval:

Sets the time interval of the date range to newTimeInterval.

- (void)setTimeInterval:(NSTimeInterval)newTimeInterval
Discussion

The time interval is only applicable when the receiver is in NSRangeDateMode.
Availability
Available in Mac OS X v10.4 and later.
See Also
– timeInterval*/
- (void)setTimeInterval:(NSTimeInterval)newTimeInterval{}


/*setDatePickerMode:

Sets the receiver’s date picker mode to newMode.

- (void)setDatePickerMode:(NSDatePickerMode)newMode
Discussion

See “Constants” for a description of the possible values.
Availability
Available in Mac OS X v10.4 and later.
See Also
– datePickerMode*/
- (void)setDatePickerMode:(NSDatePickerMode)newMode{}


/*datePickerMode

Returns the receiver’s date picker mode.

- (NSDatePickerMode)datePickerMode
Discussion

See “Constants” for a description of the possible values.
Availability
Available in Mac OS X v10.4 and later.
See Also
– setDatePickerMode:*/
- (NSDatePickerMode)datePickerMode{}

/*setMaxDate:

Sets the maximum date allowed as input by the receiver to date.

- (void)setMaxDate:(NSDate *)date
Discussion

Passing nil for date allows any date as the maximum value.
Availability
Available in Mac OS X v10.4 and later.
See Also
– maxDate*/
- (void)setMaxDate:(NSDate *)date{}

/*setBordered:

Specifies whether the receiver draws a plain border.

- (void)setBordered:(BOOL)flag
Discussion

The flag parameter specifies the Boolean value.
Availability
Available in Mac OS X v10.4 and later.
See Also
– isBordered*/
- (void)setBordered:(BOOL)flag{}

/*setBezeled:

Specifies whether the receiver has a bezeled border.

- (void)setBezeled:(BOOL)flag
Discussion

The flag parameter specifies the Boolean value.
Availability
Available in Mac OS X v10.4 and later.
See Also
– isBezeled*/
- (void)setBezeled:(BOOL)flag{}


/*setBackgroundColor:

Sets the receiver’s background color to color.

- (void)setBackgroundColor:(NSColor *)color
Availability
Available in Mac OS X v10.4 and later.
See Also
– calendar*/
- (void)setBackgroundColor:(NSColor *)color{}

/*setDelegate:

Sets the receiver’s delegate to anObject.

- (void)setDelegate:(id)anObject
Availability
Available in Mac OS X v10.4 and later.
See Also
– delegate*/
- (void)setDelegate:(id)anObject{}

/*datePickerStyle

Returns the receiver’s date picker style.

- (NSDatePickerStyle)datePickerStyle
Discussion

See “Constants” for a description of the possible values.
Availability
Available in Mac OS X v10.4 and later.
See Also
– datePickerStyle*/
- (NSDatePickerStyle)datePickerStyle{}

/*NSDatePickerElements

Returns the receiver’s date picker elements flags.

- (NSDatePickerElementFlags)datePickerElements
Discussion

See “Constants” for a description of the possible values.
Availability
Available in Mac OS X v10.4 and later.
See Also
– setDatePickerElements:*/
- (NSDatePickerElementFlags)datePickerElements{}








@end