#import <AppKit/NSPrintInfo.h>

@implementation NSPrintInfo (hys)

/*imageablePageBounds

Returns the imageable area of a sheet of paper specified by the receiver.

- (NSRect)imageablePageBounds
Return Value

The imageable area, measured in points in the user coordinate space.
Discussion

This method takes into account the current printer, paper size, and orientation settings, but not scaling factors. “Imageable area” is the maximum area that can possibly be marked on by the printer hardware, not the area defined by the current margin settings. 

The origin (0, 0) of the returned rectangle is in the lower-left corner of the oriented sheet. The imageable bounds may extend past the edges of the sheet when, for example, a printer driver specifies it so that borderless printing can be done reliably.
Availability
Available in Mac OS X v10.2 and later.*/
- (NSRect)imageablePageBounds{}

@end
