#import <Foundation/NSString.h>

/*NSWindowDidChangeScreenProfileNotification

Posted whenever the display profile for the screen containing the window changes.

This notification is sent only if the window returns YES from displaysWhenScreenProfileChanges. This notification may be sent when a majority of the window is moved to a different screen (whose profile is also different from the previous screen) or when the ColorSync profile for the current screen changes. 

The notification object is the NSWindow object whose profile changed. This notification does not contain a userInfo dictionary. 
Availability
Available in Mac OS X v10.4 and later*/
 NSString *NSWindowDidChangeScreenProfileNotification =1 

 ; 
/*NSViewGlobalFrameDidChangeNotification

Posted whenever an NSView object that has attached surfaces (that is, NSOpenGLContext objects) moves to a different screen, or other cases where the NSOpenGLContext object needs to be updated. The notification object is the surface’s view. This notification does not contain a userInfo dictionary.
Availability
Available in Mac OS X v10.1 and later.*/
NSString *NSViewGlobalFrameDidChangeNotification = 1;


#include <HYS/AppKit/NSAccessibility.h>
/*Standard attributes for any object

The following are the standard attributes that can be adopted by any object.

NSString *NSAccessibilityChildrenAttribute =1;
 NSString *NSAccessibilityContentsAttribute =1;
 NSString *NSAccessibilityDescriptionAttribute =1;
 NSString *NSAccessibilityEnabledAttribute =1;
NSString *NSAccessibilityFocusedAttribute =1;
 NSString *NSAccessibilityHelpAttribute =1; 
 NSString *NSAccessibilityMaxValueAttribute =1;
 NSString *NSAccessibilityMinValueAttribute =1;
 NSString *NSAccessibilityParentAttribute =1;
const NSString *NSAccessibilityPositionAttribute =1;
const NSString *NSAccessibilityRoleAttribute=1;
const NSString *NSAccessibilityRoleDescriptionAttribute =1;
const NSString *NSAccessibilitySelectedChildrenAttribute=1;
const NSString *NSAccessibilityShownMenuAttribute=1;
const NSString *NSAccessibilitySizeAttribute=1;
const NSString *NSAccessibilitySubroleAttribute=1;
const NSString *NSAccessibilityTitleAttribute;
const NSString *NSAccessibilityTopLevelUIElementAttribute;
const NSString *NSAccessibilityValueAttribute;
const NSString *NSAccessibilityVisibleChildrenAttribute;
const NSString *NSAccessibilityWindowAttribute;
Constants
NSAccessibilityChildrenAttribute

Elements that current element contains (NSArray)

Available in Mac OS X v10.2 and later.
NSAccessibilityContentsAttribute

Elements that represent the contents in the current element, such as the document view of a scroll view (NSArray)

Available in Mac OS X v10.2 and later.
NSAccessibilityDescriptionAttribute

Instance description (NSString).

Available in Mac OS X v10.4 and later.
NSAccessibilityEnabledAttribute

Flag indicating enabled state of element (NSNumber)

Available in Mac OS X v10.2 and later.
NSAccessibilityFocusedAttribute

Flag indicating presence of keyboard focus (NSNumber)

Available in Mac OS X v10.2 and later.
NSAccessibilityHelpAttribute

Instance description, such as a help tag string (NSString)

Available in Mac OS X v10.2 and later.
NSAccessibilityMaxValueAttribute

Element’s maximum value (id)

Available in Mac OS X v10.2 and later.
NSAccessibilityMinValueAttribute

Element’s minimum value (id)

Available in Mac OS X v10.2 and later.
NSAccessibilityParentAttribute

Element containing current element (id)

Available in Mac OS X v10.2 and later.
NSAccessibilityPositionAttribute

Screen position of element’s lower-left corner in lower-left relative screen coordinates (NSValue)

Available in Mac OS X v10.2 and later.
NSAccessibilityRoleAttribute

Element type, such as NSAccessibilityRadioButtonRole (NSString). See the role attribute table below.

Available in Mac OS X v10.2 and later.
NSAccessibilityRoleDescriptionAttribute

Localized, user-readable description of role, such as radio button (NSString)

Available in Mac OS X v10.2 and later.
NSAccessibilitySelectedChildrenAttribute

Currently selected children (NSArray)

Available in Mac OS X v10.2 and later.
NSAccessibilityShownMenuAttribute

Menu currently being displayed (id).

Available in Mac OS X v10.4 and later.
NSAccessibilitySizeAttribute

Element size (NSValue)

Available in Mac OS X v10.2 and later.
NSAccessibilitySubroleAttribute

Element subrole type, such as NSAccessibilityTableRowSubrole (NSString). See the subrole attribute table below.

Available in Mac OS X v10.2 and later.
NSAccessibilityTitleAttribute

Title of element, such as button text (NSString)

Available in Mac OS X v10.2 and later.
NSAccessibilityTopLevelUIElementAttribute

User interface element for the top-level element (id).

Available in Mac OS X v10.4 and later.
NSAccessibilityValueAttribute

Element’s value (id)

Available in Mac OS X v10.2 and later.
NSAccessibilityVisibleChildrenAttribute

Child elements that are visible (NSArray)

Available in Mac OS X v10.2 and later.
NSAccessibilityWindowAttribute

Window containing current element (id)

Available in Mac OS X v10.2 and later.
Declared In
NSAccessibility.h
Text-specific attributes*/

const NSString *NSAccessibilityChildrenAttribute;
const NSString *NSAccessibilityContentsAttribute;
const NSString *NSAccessibilityDescriptionAttribute;
const NSString *NSAccessibilityEnabledAttribute;
const NSString *NSAccessibilityFocusedAttribute;
const NSString *NSAccessibilityHelpAttribute;
const NSString *NSAccessibilityMaxValueAttribute;
const NSString *NSAccessibilityMinValueAttribute;
const NSString *NSAccessibilityParentAttribute;
const NSString *NSAccessibilityPositionAttribute;
const NSString *NSAccessibilityRoleAttribute;
const NSString *NSAccessibilityRoleDescriptionAttribute;
const NSString *NSAccessibilitySelectedChildrenAttribute;
const NSString *NSAccessibilityShownMenuAttribute;
const NSString *NSAccessibilitySizeAttribute;
const NSString *NSAccessibilitySubroleAttribute;
const NSString *NSAccessibilityTitleAttribute;
const NSString *NSAccessibilityTopLevelUIElementAttribute;
const NSString *NSAccessibilityValueAttribute;
const NSString *NSAccessibilityVisibleChildrenAttribute;
const NSString *NSAccessibilityWindowAttribute;

/*Table view and outline view attributes

The following are attributes specific to tables and outlines.

const NSString *NSAccessibilityColumnsAttribute;
const NSString *NSAccessibilityRowsAttribute;
const NSString *NSAccessibilitySelectedColumnsAttribute;
const NSString *NSAccessibilitySelectedRowsAttribute;
const NSString *NSAccessibilitySortDirectionAttribute;
const NSString *NSAccessibilityVisibleColumnsAttribute;
const NSString *NSAccessibilityVisibleRowsAttribute;
Constants
NSAccessibilityColumnsAttribute

Table’s columns (NSArray)

Available in Mac OS X v10.2 and later.
NSAccessibilityRowsAttribute

Table’s rows (NSArray)

Available in Mac OS X v10.2 and later.
NSAccessibilitySelectedColumnsAttribute

Table’s selected columns (NSArray)

Available in Mac OS X v10.2 and later.
NSAccessibilitySelectedRowsAttribute

Table’s selected rows (NSArray)

Available in Mac OS X v10.2 and later.
NSAccessibilitySortDirectionAttribute

Column’s sort direction.

Available in Mac OS X v10.4 and later.
NSAccessibilityVisibleColumnsAttribute

Table’s visible columns (NSArray)

Available in Mac OS X v10.2 and later.
NSAccessibilityVisibleRowsAttribute

Table’s visible rows (NSArray)

Available in Mac OS X v10.2 and later.
Declared In
NSAccessibility.h*/
const NSString *NSAccessibilityColumnsAttribute;
const NSString *NSAccessibilityRowsAttribute;
const NSString *NSAccessibilitySelectedColumnsAttribute;
const NSString *NSAccessibilitySelectedRowsAttribute;
const NSString *NSAccessibilitySortDirectionAttribute;
const NSString *NSAccessibilityVisibleColumnsAttribute;
const NSString *NSAccessibilityVisibleRowsAttribute;

/*NSFontSetChangedNotification

Posted after the the currently-set font changes.

Availability
Available in Mac OS X v10.4 and later.*/
const NSString *NSFontSetChangedNotification;