#include <DiscRecordingEngine/DRMSF.h>

 @implementation  DRMSF

/*msfWithFrames:


Creates an msf object whose length is frames. 
private

+ (DRMSF*) msfWithFrames:(unsigned long)frames; 
Return Value

An autoreleased DRMSF object.*/
+ (DRMSF*) msfWithFrames:(unsigned long)frames{}


/*descriptionWithFormat:


Returns a textual representation of the receiver. 
private

- (NSString*) descriptionWithFormat:(NSString*) format; 
Parameters
format
The format of the description string.
Return Value

NSString containing a textual representation of the object utilizing the specified format. 
Discussion 

The format string is very similar to a printf-style format string with %-escaped formatting characters.
%% A "%" character
%m Minutes as a decimal number
%s Seconds as a decimal number
%f Frames as a decimal number

In addition to these formatting characters an optional length specifier can come between then % and the formatting character. This length specifier will force the field in question to be at least that wide. For example a format specifier of "%02m:%02s" will cause a DRMSF object representing 3 minutes 9 seconds to be formatted as "03:09". 
A formatter is aware of and respects rounding. If a bit of the msf is not zero, but the format does not display that value, the next higher value will be increased by one to reflect that. Extending our example above, an DRMSF with a value of 3 minutes, 9 seconds, 15 frames using a format specfier of "%02m:%02s", will be formatted as "03:10" since the 15 frames rounds up the seconds to the next value*/
- (NSString*) descriptionWithFormat:(NSString*) format{}


@end
