#import <Foundation/NSString.h>

/*Constants

The following constants define keys that can be passed in an options dictionary when you create a context.
Constant	
Description
kCIContextOutputColorSpace	
Specifies the color space to use for images before they are rendered to the context. By default, Core Image uses the GenericRGB color space, which leaves color matching to the system. You can specify a different output color space by providing a Quartz 2D CGColorSpace object (CGColorSpaceRef). (See Quartz 2D Programming Guide for information on creating and using CGColorspace objects.)
kCIContextWorkingColorSpace	
Specifies a color space to use for image operations. By default, Core Image assumes that processing nodes are 128 bits-per-pixel, linear light, premultiplied RGBA floating-point values that use the GenericRGB color space. You can specify a different working color space by providing a Quartz 2D CGColorSpace object (CGColorSpaceRef). Note that the working color space must be RGB-based. If you have YUV data as input (or other data that is not RGB-based), you can use ColorSync functions to convert to the working color space. (See Quartz 2D Programming Guide for information on creating and using CGColorspace objects.)
kCIContextUseSoftwareRenderer	
Specifies whether or not to require the software renderer. If that associated NSNumber object is YES, then the software renderer is required.*/
NSString *kCIContextOutputColorSpace =1; //?
NSString *kCIContextWorkingColorSpace =1; //?
NSString *kCIContextUseSoftwareRenderer =1;//?
NSString *kCIFormatARGB8=1;//?
NSString *kCIFormatRGBA16=1;	//?
NSString *kCIFormatRGBAf=1;//?
